﻿--[[

    etc_dhtblocker_0.1.lua by pulsar

        Version: Luadch_0.08

        - DHT Blocker, um zu gewährleisten das User mit aktiver 'Torrent-Search-Engine' disconnected werden.

		+ Translated to english by tonimontana
		
			- DHT Blocker - this script is to make sure that users with activated DHT function get disconnected
]]--


--------------
--[SETTINGS]--
--------------

--> Scriptname
local scriptname = "etc_dhtblocker"

--> Warning message to the user with activated DHT function
local dhtusermsg = [[

                                    +++  WARNiNG - PLEASE READ THiS +++

        The DHT function for the alternative source search is activated in some clients by default. 
		This is a high security risk and therefore you are disconnected.

        Information: The DHT function works basically like 'DHT in the BitTorrent Network'. 
		The torrent clients share the informations about seeds between each other and so they build 
		a bigger virtual network where clients that are not connected to the same tracker can connect 
		to each other. 
		And in the same way it works in the DC Network. No matter if you are connected to a particular 
		hub or not, you will establish a connection to a kind of "virtual hub". Every user with this 
		function enabled in his client can access your files!!!
		Basically this sounds like a nice feature to be able to download from somebody who is not on 
		the same hub but as long as DHT is not encrypted it is a security risk for DC/ADC users that 
		are connected to private hubs (and of course its also a security risk for the private hub).
        Your DC/ADC client will turn into "a kind of server" and your ip will be shared between all clients 
		in the network which have the DHT function enabled.
        This counts for all StrongDC++ Clients V. 2.30+, and for all clients that are based on it (RSX, Apex ...)

        What to do now?: To deactivate the DHT function, go into the 'Settings-Menu' and there you click on 
		'Advanced'. On the right side scroll down to the bottom of the list, and there you deselect: 
		'Publish shared files on DHT and use it for searching alternate sources'.
        Now restart your client and reconnect to the hub. You should now be able to connect to the hub again.

        Best regards
		Your well known Hubteam

    ]]

--> Should the Hubteam be informed about the disconnected 'DHT-User' (in pm by the hubbot)? (true=Yes/false=No)
local blockdhtinfo = true
--> Hubteam Minlevel
local minlevel = 60
--> Message for the Hubteam
local dhtteammsg = "Warning: The following User is disconnected cause he have DHT feature enabled:  "

--> Should all users be informed in mainchat about the blocked 'DHT-User'? (true=Yes/false=No)
local blockdhtmaininfo = false
--> Message for the other User's
local dhtmainmsg = "Warning: The following User is disconnected cause he have DHT feature enabled:  "


----------
--[CODE]--
----------

local blockDHT = function(user, adccmd)
    local adcstr = adccmd:adcstring()
    local dht1 = user:supports("DHT0")
    local dht2 = user:supports("ADDHT0")
    local user_nick = user:nick()
    local hub_getusers = hub.getusers()
    local hub_getbot = hub.getbot()
    local hub_broadcast = hub.broadcast
    if dht1 or dht2 then
        user:reply(dhtusermsg, hub_getbot)
        user:kill("sorry")
        if blockdhtinfo == true then
            for sid, user in pairs(hub_getusers) do
                local opuser = user:level()
                if opuser >= minlevel then
                    user:reply(dhtteammsg..user_nick, hub_getbot, hub_getbot)
                end
            end
        end
        if blockdhtmaininfo == true then
            hub_broadcast(dhtmainmsg..user_nick, hub_getbot)
        end
        return PROCESSED
    end
    return nil
end

hub.setlistener("onInf", {}, blockDHT)
hub.setlistener("onSearch", {}, blockDHT)

hub.debug("** Loaded "..scriptname..".lua **")

---------
--[END]--
---------
